Attribute VB_Name = "modCrypt"
Option Explicit
Option Base 0



Private aDecTab(255) As Integer
Private Const sEncTab As String = _
    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
Function EnCryptSpecial(strPassword As String, strInput As String) As String
    Dim PasswordVal As Long, CurrentChar As Long, CurrentMod As Long
    Dim I As Long
    'Lets turn our password into a number! Yippee!
    PasswordVal = GetPasswordValue(strPassword)
    
    'CurrentMod will makes it difficult to recognise when we use the same character more than once.
    CurrentMod = 2
    
    For I = 1 To Len(strInput)
        CurrentChar = Asc(Mid(strInput, I, 1))
        'Set currentchar as the ASCII value of the the character being encrypted
        CurrentChar = CurrentChar + PasswordVal
        
        'CurrentMod is passed into CalculateSeed - See that function for more details.
        CurrentChar = CurrentChar - CalculateSeed(CLng(CurrentMod))
                
        CurrentChar = WrapNumber(CurrentChar, 0, 255)
        
        EnCryptSpecial = EnCryptSpecial & Chr(CurrentChar)
        
        CurrentMod = CurrentMod + 1
        If CurrentMod > 30 Then CurrentMod = 2
    Next I
End Function

Function DeCryptSpecial(strPassword As String, ByVal strInput As String) As String
    Dim PasswordVal As Long, CurrentChar As Long, CurrentMod As Long
    
    'Lets turn our password into a number! Yippee!
    PasswordVal = GetPasswordValue(strPassword)
    CurrentMod = 2
    Dim I As Long
    
    For I = 1 To Len(strInput)
        CurrentChar = Asc(Mid(strInput, I, 1))
        'Set currentchar as the ASCII value of the the character being encrypted
        CurrentChar = CurrentChar - PasswordVal
        
        'CurrentMod is passed into CalculateSeed - See that function for more details.
        CurrentChar = CurrentChar + CalculateSeed(CLng(CurrentMod))
        
        'We need to make sure that CurrentChar ends up being between 0 and 255, so we wrap it!
        CurrentChar = WrapNumber(CurrentChar, 0, 255)
        
        DeCryptSpecial = DeCryptSpecial & Chr(CurrentChar)
        
        'Add 1 to CurrentMod (For calculated randomization)
        CurrentMod = CurrentMod + 1
        If CurrentMod > 30 Then CurrentMod = 2
    Next I
End Function

Private Function GetPasswordValue(strPassword As String) As Long
    Dim ASCII_Vals As Long
    Dim I As Long
    For I = 1 To Len(strPassword)
        'We need to add up all the ASCII values from all the characters
        ASCII_Vals = ASCII_Vals + Asc(Mid(strPassword, I, 1))
    Next I
    
    If ASCII_Vals > Len(strPassword) Then
        'Divide the Calculated Random Number (CRN) of ASCII_Vals by the CRN of the length of the password.
        GetPasswordValue = Int(CalculateSeed(ASCII_Vals) / CalculateSeed(Len(strPassword) + 1))
    Else
        'We would end up with 0 if we divided, so we aint gonna divide!
        'We will just use the CRN ASCII_Vals produces.
        GetPasswordValue = CalculateSeed(ASCII_Vals)
    End If
    
End Function

Private Function CalculateSeed(InputNumber As Long) As Long
    'This functions pretty much makes the InputNumber appear to become a totally random
    'number, but unke using rnd (Random Function) this will always return the same number
    'as long as you enter the same number.
    
    'Log and Cos are just Maths functions
    
    CalculateSeed = Int(Log(InputNumber) * Cos(InputNumber) * 137)
End Function

Private Function WrapNumber(lngNumber As Long, lngMinimum As Long, lngMaximum As Long) As Long
    Dim Range As Long
    Range = lngMaximum - lngMinimum
    'This function 'wraps' numbers.
    'If u want a number to be in a certain range (say between 0 and 255)
    'this funciton will make any number fit into that range!
     WrapNumber = lngNumber
     
     If lngNumber > lngMaximum Then
        Do Until WrapNumber <= lngMaximum
            WrapNumber = WrapNumber - Range
        Loop
     ElseIf lngNumber < lngMinimum Then
        Do Until WrapNumber >= lngMinimum
            WrapNumber = WrapNumber + Range
        Loop
     End If
    
End Function
Public Function EncodeStr64(sInput As String) As String
' Return radix64 encoding of string of binary values
' Does not insert CRLFs. Just returns one long string,
' so it's up to the user to add line breaks or other formatting.
' Version 3: Use Mid$() function instead of appending
    Dim sOutput As String, sLast As String
    Dim B(2) As Byte
    Dim j As Integer
    Dim I As Long, nLen As Long, nQuants As Long
    Dim iIndex As Long
    
    nLen = Len(sInput)
    nQuants = nLen \ 3
    sOutput = String(nQuants * 4, " ")
    iIndex = 0
    ' Now start reading in 3 bytes at a time
    For I = 0 To nQuants - 1
        For j = 0 To 2
           B(j) = Asc(Mid(sInput, (I * 3) + j + 1, 1))
        Next
        Mid$(sOutput, iIndex + 1, 4) = EncodeQuantum(B)
        iIndex = iIndex + 4
    Next
    
    ' Cope with odd bytes
    Select Case nLen Mod 3
    Case 0
        sLast = ""
    Case 1
        B(0) = Asc(Mid(sInput, nLen, 1))
        B(1) = 0
        B(2) = 0
        sLast = EncodeQuantum(B)
        ' Replace last 2 with =
        sLast = Left(sLast, 2) & "=="
    Case 2
        B(0) = Asc(Mid(sInput, nLen - 1, 1))
        B(1) = Asc(Mid(sInput, nLen, 1))
        B(2) = 0
        sLast = EncodeQuantum(B)
        ' Replace last with =
        sLast = Left(sLast, 3) & "="
    End Select
    
    EncodeStr64 = sOutput & sLast
End Function

Public Function DecodeStr64(sEncoded As String) As String
' Return string of decoded binary values given radix64 string
' Ignores any chars not in the 64-char subset
' Version 3: Use Mid$() function instead of appending
    On Error GoTo fehler
    Dim sDecoded As String
    
    Dim D(3) As Byte
    Dim C As Byte
    Dim di As Integer
    Dim I As Long
    Dim nLen As Long
    Dim iIndex As Long
    
    nLen = Len(sEncoded)
    sDecoded = String((nLen \ 4) * 3, " ")
    iIndex = 0
    di = 0
    Call MakeDecTab
    ' Read in each char in trun
    For I = 1 To Len(sEncoded)
        C = CByte(Asc(Mid(sEncoded, I, 1)))
        C = aDecTab(C)
        If C >= 0 Then
            D(di) = C
            di = di + 1
            If di = 4 Then
                Mid$(sDecoded, iIndex + 1, 3) = DecodeQuantum(D)
                iIndex = iIndex + 3
                If D(3) = 64 Then
                    sDecoded = Left(sDecoded, Len(sDecoded) - 1)
                    iIndex = iIndex - 1
                End If
                If D(2) = 64 Then
                    sDecoded = Left(sDecoded, Len(sDecoded) - 1)
                    iIndex = iIndex - 1
                End If
                di = 0
            End If
        End If
    Next I
    
    DecodeStr64 = sDecoded
    DoEvents
    Exit Function
fehler:
End Function

Private Function EncodeQuantum(B() As Byte) As String
    Dim sOutput As String
    Dim C As Integer
    
    sOutput = ""
    C = SHR2(B(0)) And &H3F
    sOutput = sOutput & Mid(sEncTab, C + 1, 1)
    C = SHL4(B(0) And &H3) Or (SHR4(B(1)) And &HF)
    sOutput = sOutput & Mid(sEncTab, C + 1, 1)
    C = SHL2(B(1) And &HF) Or (SHR6(B(2)) And &H3)
    sOutput = sOutput & Mid(sEncTab, C + 1, 1)
    C = B(2) And &H3F
    sOutput = sOutput & Mid(sEncTab, C + 1, 1)
    
    EncodeQuantum = sOutput
    
End Function

Private Function DecodeQuantum(D() As Byte) As String
    Dim sOutput As String
    Dim C As Long
    
    sOutput = ""
    C = SHL2(D(0)) Or (SHR4(D(1)) And &H3)
    sOutput = sOutput & Chr$(C)
    C = SHL4(D(1) And &HF) Or (SHR2(D(2)) And &HF)
    sOutput = sOutput & Chr$(C)
    C = SHL6(D(2) And &H3) Or D(3)
    sOutput = sOutput & Chr$(C)
    
    DecodeQuantum = sOutput
    
End Function

Private Function MakeDecTab()
' Set up Radix 64 decoding table
    Dim t As Integer
    Dim C As Integer

    For C = 0 To 255
        aDecTab(C) = -1
    Next
  
    t = 0
    For C = Asc("A") To Asc("Z")
        aDecTab(C) = t
        t = t + 1
    Next
  
    For C = Asc("a") To Asc("z")
        aDecTab(C) = t
        t = t + 1
    Next
    
    For C = Asc("0") To Asc("9")
        aDecTab(C) = t
        t = t + 1
    Next
    
    C = Asc("+")
    aDecTab(C) = t
    t = t + 1
    
    C = Asc("/")
    aDecTab(C) = t
    t = t + 1
    
    C = Asc("=")    ' flag for the byte-deleting char
    aDecTab(C) = t  ' should be 64

End Function

' Version 3: ShiftLeft and ShiftRight functions improved.
Public Function SHL2(ByVal bytValue As Byte) As Byte
' Shift 8-bit value to left by 2 bits
' i.e. VB equivalent of "bytValue << 2" in C
    SHL2 = (bytValue * &H4) And &HFF
End Function

Public Function SHL4(ByVal bytValue As Byte) As Byte
' Shift 8-bit value to left by 4 bits
' i.e. VB equivalent of "bytValue << 4" in C
    SHL4 = (bytValue * &H10) And &HFF
End Function

Public Function SHL6(ByVal bytValue As Byte) As Byte
' Shift 8-bit value to left by 6 bits
' i.e. VB equivalent of "bytValue << 6" in C
    SHL6 = (bytValue * &H40) And &HFF
End Function

Public Function SHR2(ByVal bytValue As Byte) As Byte
' Shift 8-bit value to right by 2 bits
' i.e. VB equivalent of "bytValue >> 2" in C
    SHR2 = bytValue \ &H4
End Function

Public Function SHR4(ByVal bytValue As Byte) As Byte
' Shift 8-bit value to right by 4 bits
' i.e. VB equivalent of "bytValue >> 4" in C
    SHR4 = bytValue \ &H10
End Function

Public Function SHR6(ByVal bytValue As Byte) As Byte
' Shift 8-bit value to right by 6 bits
' i.e. VB equivalent of "bytValue >> 6" in C
    SHR6 = bytValue \ &H40
End Function

Public Function Encode(sText As String)
    Encode = EncodeStr64(sText)
End Function

Public Function Decode(sText As String)
    Decode = DecodeStr64(sText)
End Function
